mod users;

use axum::extract::Extension;
use axum::extract::Path;
use axum::{
    routing::{get, post},
    Router,
};
use sqlx::postgres::PgPoolOptions;
use std::sync::Arc;

#[tokio::main]
async fn main() -> anyhow::Result<()> {
    let pool = Arc::new(
        PgPoolOptions::new()
            .connect("postgresql://tmtd@192.168.1.133/tmtd")
            .await?,
    );

    sqlx::query("create table if not exists users(id serial primary key, username text not null, password_hash text not null)").execute(&*pool).await?;

    let app = Router::new()
        .route("/:name", get(say_hello))
        .route("/register", post(users::create_user))
        .route("/login", get(users::login_form))
        .layer(Extension(pool));

    axum::Server::bind(&"0.0.0.0:3000".parse().unwrap())
        .serve(app.into_make_service())
        .await
        .unwrap();

    Ok(())
}

async fn say_hello(Path(name): Path<String>) -> String {
    format!("Hello, {}!", name)
}
